import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Random;
/**
  *
  * Klasse fr einen intelligenten Computerspieler
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class ComputerSpieler extends Spieler {

  private int suchtiefe;
  private int zug;
  private JFrame owner;


  public ComputerSpieler(JFrame owner, int maximaleSuchtiefe)
  {
    this.owner = owner;
    this.suchtiefe = maximaleSuchtiefe;
  }
  
  private int bewertungsfunktion(Position position)
  {
    if (position.augenSumme() < position.zielzahl())
      return 0;
    else
      return 1;
  }
  
  private void printab(int alpha, int beta, Position pos, int tiefe)
  {
    String s = "                                                                                ".substring(0,(suchtiefe-tiefe)*5);
    s = s + "("+alpha+" / "+beta+")    "+pos.augen()+"/"+pos.augenSumme()+"\n";
    System.out.print(s);
  }
  
  private int negamax(Position position, int tiefe, int alpha, int beta)
  {
    //printab(alpha,beta,position,tiefe);
    if (position.spielendeErreicht() || (tiefe <= 1))
      return -bewertungsfunktion(position);
    else {
      int wert;
      for (int probezug = 1; probezug <= 6; probezug++) {
        if (position.zulaessig(probezug)) {
          Position folgeposition = position.folgePosition(probezug);
          wert = -negamax(folgeposition, tiefe - 1, -beta, -alpha);
          if (wert > alpha) {
            alpha = wert;
            if (tiefe == suchtiefe)
              zug = probezug;
            if (wert >= beta) {
//              System.out.print("           -----------------------------------"+wert);
//              printab(alpha,beta,position,tiefe);
              return beta;

            }
          }
        }
      }
      return alpha;
    }
  }
  
  
  public int spielzugMachen(Position position)
  {
    Random r = new Random();
    
    int wert = negamax(position,suchtiefe,-Integer.MAX_VALUE,Integer.MAX_VALUE);
    if (wert = -Integer.MAX_VALUE) {
      do
        zug = r.nextInt(6)+1;
      while (!position.zulaessig(zug));
    }

    JOptionPane.showConfirmDialog(owner,"Computer dreht auf "+zug,"Computerzug",JOptionPane.OK_CANCEL_OPTION,JOptionPane.INFORMATION_MESSAGE);
    return zug;
  }

}
