/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class Position {

  private int augen;
  private int augenSumme;
  private int amZug;
  private int zielzahl;
  
  public Position()
  {
    augen = 0;
    augenSumme = 0;
    amZug = 0;
  }
  
  public Position(int augen, int spieler, int zielzahl)
  {
    this.augen = augen;
    this.augenSumme = 0;
    this.amZug = spieler;
    this.zielzahl = zielzahl;
  }

  public int augen()
  {
    return augen;
  }
  
  public int augenSumme()
  {
    return augenSumme;
  }
  
  public int amZug()
  {
    return amZug;
  }
  
  public int zielzahl()
  {
    return zielzahl;
  }
  
  public void zugAusfuehren(int zug)
  {
    augenSumme += zug;
    augen = zug;
    amZug = 1 - amZug;
  }
  
  public boolean zulaessig(int zug)
  {
    if ((this.augen != zug) && (this.augen != 7-zug) && (zug >= 1) && (zug <= 6) && (augenSumme + zug <= zielzahl))
      return true;
    else
      return false;
  }
  
  public Position folgePosition(int zug)
  {
    Position result = new Position(this.augen, this.amZug, this.zielzahl);
    result.augenSumme = this.augenSumme;
    result.zugAusfuehren(zug);
    return result;
  }
  
  public boolean spielendeErreicht()
  {
    if ( (augenSumme == zielzahl) ||
         ( (augenSumme == zielzahl-1) && ( (augen == 1) || (augen == 6) ) ) )
      return true;
    else
      return false;
  }

}
