import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class Spiel {

  private Position position;
  private Gui owner;
  private Spieler[] spieler = new Spieler[2];
  
  public Spiel(Gui owner)
  {
    this.owner = owner;
    position = new Position(1,1, 20);
  }
  
  public Spiel(int startzahl, int zielzahl, int startspieler, Gui owner)
  {
    this.owner = owner;
    position = new Position(startzahl,startspieler, zielzahl);
    
    spieler[0] = new MenschSpieler(owner);
    spieler[1] = new ComputerSpieler(owner,15);
  }
  
  public void starten()
  {
    int zug;
    while (!position.spielendeErreicht()) {
      do
        zug = spieler[position.amZug()].spielzugMachen(position);
      while (!position.zulaessig(zug));
      position.zugAusfuehren(zug);
      owner.ausgabe(position);
    }
    
    if (position.augenSumme() < position.zielzahl())
      JOptionPane.showConfirmDialog(owner,"Das Spiel endet Remis","Spielende",JOptionPane.OK_CANCEL_OPTION,JOptionPane.INFORMATION_MESSAGE);
    else if (position.amZug() == 0) 
      JOptionPane.showConfirmDialog(owner,"Spieler 1 gewinnt!","Spielende",JOptionPane.OK_CANCEL_OPTION,JOptionPane.INFORMATION_MESSAGE);
    else
      JOptionPane.showConfirmDialog(owner,"Spieler 0 gewinnt!","Spielende",JOptionPane.OK_CANCEL_OPTION,JOptionPane.INFORMATION_MESSAGE);
  }
  
}
